require "./lib/dieta/menu.rb"
# Clase Menú con edad (hija de la clase Menu)
# @author alu0100880625
# @attr_reader [String] edad Cadena que almacena el rango de edades
class Menu_edad < Menu
	attr_reader :edad
# Método que instancia un objeto de la clase
# @param [Array] encabezado Array de Strings que almacena el título y el porcentaje de ingesta diaria
# @param [Array] platos Array bidimensional de Strings que almacena los ingredientes y cantidades, la forma de cocinar y las unidades
# @param [Array] valores Array que contiene los valores nutricionales y porcentaes
# @param [String] edad Almacena el rango de edades
# @return [Object]
	def initialize(edad, encabezado, platos, valores)
		super(encabezado,platos,valores)
		@edad=edad
	end
# Método que retorna el rango de edades
# @return [String] rango de edades
	def get_edad
		@edad
	end
# Método que formatea el menú para mostrarlo
# @return [String] cadena que contiene el menú formateado
	def to_s
		aux="Edad: #{@edad}\n"
		aux+=super()
	end
end
