require "./lib/dieta/menu.rb"
# Clase Menú con edad (hija de la clase Menu)
# @author alu0100880625
# @attr_reader [String] grupo Cadena que almacena el grupo del menú
class Menu_grupo < Menu
	attr_reader :grupo
# Método que instancia un objeto de la clase
# @param [Array] encabezado Array de Strings que almacena el título y el porcentaje de ingesta diaria
# @param [Array] platos Array bidimensional de Strings que almacena los ingredientes y cantidades, la forma de cocinar y las unidades
# @param [Array] valores Array que contiene los valores nutricionales y porcentaes
# @param [String] grupo Almacena el grupo del menú
# @return [Object]
	def initialize(grupo, encabezado, platos, valores)
		super(encabezado,platos,valores)
		@grupo=grupo
	end
# Método que retorna el grupo del menú
# @return [String] grupo del menú
	def get_grupo
		@grupo
	end
# Método que formatea el menú para mostrarlo
# @return [String] cadena que contiene el menú formateado
	def to_s
		aux="Grupo: #{@grupo}\n"
		aux+=super()
	end
end
